#TEMPLATE (OleObjectControl,'OLE/OCX Object Control 6.0 Beta 1'),FAMILY('ABC')
#!
#! Version: 1.0 Beta 1 (Clarion4 Only)
#!
#! Author: George Petrov
#! Dated : 30.08.1998
#! ! Modified for Clarion 6 - January 2004 - Jim Katz
#INCLUDE('ABGROUP.TPW')
#!-----------------------------------------------------------------------------
#!
#EXTENSION(OleObjectDeclare,'Declare Extra Ole/Ocx Objects'),DESCRIPTION('Declare Extra Ole/Ocx Objects')
#BUTTON('Declare Extra Ole/Ocx Objects'),INLINE,MULTI(%ExtraOleObjects,%ExtraOleObject & ' - ' & %ExtraOleObjectType)
  #PROMPT('&Object Name:',@S255),%ExtraOleObject,REQ
  #PROMPT('Base &Class:',FROM(%pClassName)),%ExtraOleObjectType,REQ
#ENDBUTTON
#!
#AT(%LocalDataClasses)
#FOR(%ExtraOleObjects)
%ExtraOleObject %ExtraOleObjectType
#ENDFOR
#ENDAT
#!
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(8500)
#FOR(%ExtraOleObjects)
%ExtraOleObject.Init()
#ENDFOR
#ENDAT
#!
#AT(%WindowManagerMethodCodeSection,'Kill','(),BYTE'),PRIORITY(7500)
#FOR(%ExtraOleObjects)
%ExtraOleObject.Kill()
#ENDFOR
#ENDAT
#!
#!
#!-----------------------------------------------------------------------------
#!
#CONTROL(OleObjectControl,'Ole/Ocx Object Control 6.0 Beta 1'),DESCRIPTION('OLE/OCX Object Control - ' & %ThisObjectName),MULTI,WINDOW
  CONTROLS
    OLE,USE(?OleControl)
  END
#!
#BOXED('Default Ole Object prompts'),AT(0,0),WHERE(%False),HIDE
  #PROMPT('',@s32),%OleObject
  #INSERT(%OOPHiddenPrompts(ABC))
#ENDBOXED
#PREPARE
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassDefaults(ABC),'OleObjectClass','OleObject:'&%ActiveTemplateInstance,%OleObjectClass)
  #CALL(%BuildObjectList(ABC))
#ENDPREPARE
#!
#BOXED('Class && Scope')
#PROMPT('OLE Object Class:', FROM(%pClassName)),%OleObjectClass,DEFAULT('OleObjectClass'),REQ
#DISPLAY('OLE Object: '& %OleObjectClass)
#WITH(%ClassItem,'OleObjectClass')
  #INSERT(%ClassPrompts(ABC))
#ENDWITH
#ENDBOXED
#!
#ATSTART
  #DECLARE(%EnabledEvents),MULTI,UNIQUE
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassDefaults(ABC),'OleObjectClass','OleObject:'&%ActiveTemplateInstance,%OleObjectClass)
  #SET(%OleObject,%ThisObjectName)
  #DECLARE(%OleObjectControl)
  #!
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #SET(%OleObjectControl,%Control)
  #ENDFOR
  #!
#ENDAT
#!
#AT(%GatherObjects)
#CALL(%AddObjectList(ABC),'OleObjectClass')
#ENDAT
#AT(%AfterGlobalIncludes)
   INCLUDE('COLEOBJ.INC'),ONCE
#ENDAT

#!
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(8500)
%OleObject.Init(%Window,%OleObjectControl)
#ENDAT
#!
#AT(%WindowManagerMethodCodeSection,'TakeEvent','(),BYTE'),PRIORITY(3750)
IF FIELD() = %OleObjectControl THEN
  %OleObject.HandleEvent()
END
#ENDAT
#!
#AT(%WindowManagerMethodCodeSection,'Kill','(),BYTE'),PRIORITY(7500)
%OleObject.Kill()
#ENDAT
#!
#AT(%OLEObjectClassCodeSection,%ActiveTemplateInstance,'Methods','EnableEvents','()'),PRIORITY(7500)
!Enable Events
%%COleObject_EnableEvents
#ENDAT
#!
#AT(%OLEObjectClassCodeSection,%ActiveTemplateInstance),PRIORITY(5000)
  #CALL(%GenerateParentCall(ABC))
#ENDAT
#!

#!! Setup Virtual method embed points in the embed tree
#AT(%LocalProcedures)
#CALL(%GenerateVirtuals(ABC), 'OleObjectClass', 'Local Objects|Abc Objects|OLE Object Class','%OLEObjectClassVirtuals(OleObjectControl)')
#ENDAT
#!
#AT(%LocalDataClasses)
#INSERT(%GenerateClass(ABC), 'OLEObjectClass')
  MAP
    %OleObject_EnableEvents
  END
#ENDAT
#!
#ATEND
#!
%OleObject_EnableEvents PROCEDURE
  !Enable Events for %OleObject
  CODE
#FOR(%EnabledEvents)
  %OleObject.Enable_%(CHOOSE(SUB(%EnabledEvents,1,3)='OLE',SUB(%EnabledEvents,4,LEN(%EnabledEvents)-3),%EnabledEvents)) = True
#ENDFOR
#ENDAT
#!
#GROUP(%OLEObjectClassVirtuals, %TreeText, %DataText, %CodeText)
#EMBED(%OLEObjectClassDataSection,'OLE Object Class Method Data Section'),%ActiveTemplateInstance,%pClassMethod,%pClassMethodPrototype,LABEL,DATA,PREPARE(CALL(%FixClassName,%FixBaseClassToUse('OLEObjectClass'))),TREE(%TreeText & %DataText)
  #?CODE
  #EMBED(%OLEObjectClassCodeSection,'OLE Object Class Method Executable Code Section'),%ActiveTemplateInstance,%pClassMethod,%pClassMethodPrototype,PREPARE(CALL(%FixClassName,%FixBaseClassToUse('OLEObjectClass'))),TREE(%TreeText & %CodeText)
#!


